stages:
    - build
    - test
    - deploy
    - stop
    - build docker
    - test docker

variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest

default:
    image: node:14
    cache:
        key: $CI_COMMIT_REF_SLUG
        paths:
            - .npm 
        policy: pull # pull / push ou pullpush

build WebSite:
    stage: build
    artifacts:
        paths: 
            - public
    script: 
        - echo "build WebSite"
        - npm ci --cache .npm --prefer-offline 
        - npm run build

docker build:
    image: docker:20.10.7
    stage: build docker
    services:
        - docker:20.10.7-dind
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $IMAGE_TAG -t $IMAGE_TAG_LATEST .
        - docker push $IMAGE_TAG
        - docker push $IMAGE_TAG_LATEST

test docker:
    stage: test docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - apk add --update curl
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker pull $IMAGE_TAG
        - docker run -d -p 8080:80 --name webstie $IMAGE_TAG
        - sleep 10
        - curl http://docker:8080 | tac | tac | grep  "build something great"


.test WebSite:
    image: alpine:latest
    stage: test
    script: 
        - echo "test WebSite"
        - grep "build something great" ./public/index.html

.surge deploy test:
    environment: 
        name: test
        on_stop: stop_test
        url: $SURGE_URL
    stage: deploy
    only:
        - master
    script:
        - npx surge --project ./public --domain $SURGE_URL

.surge deploy prod:
    environment: 
        name: production
        url: $SURGE_URL
    when: manual
    stage: deploy
    only:
        - master
    script:
        - npx surge --project ./public --domain $SURGE_URL

.stop_test:
    stage: stop
    script:
        - npx surge teardown $SURGE_URL
    environment:
        name: test
        action: stop
    when: manual